//====================================================
//$RCSfile: common.mjs,v $
//$Revision: 1.3 $
//$State: Exp $
//$Locker:  $
//
//last change: $Date: 2007/01/17 14:17:53 $
//             $Author: Pavel $
//
//Copyright (C) 2004 RNMC
//====================================================
	//	================================================================================================================================
	//		common const
	//	================================================================================================================================
	
	//   
	CONTROL_TYPE_BUTTON = 0;
	CONTROL_TYPE_GROUP = 1;
	CONTROL_TYPE_PLAYCONTROL = 2;
	CONTROL_TYPE_TEXTBOX = 3;
	
	// common_collection
	
	COLLECTION_MODE_ALL = 0;
	COLLECTION_MODE_SINGLE = 1;
	COLLECTION_MODE_LIST = 2;
	
	// common_hint
	
	HINT_TYPE_TEXT = 0;
	HINT_TYPE_IMAGE = 1;
	HINT_DELAY = 3000;
	HINT_DURATION = 4000;
	
	// common_button
	
	BUTTON_TYPE_TEXT = 0;
	BUTTON_TYPE_IMAGE = 1;
	
	// SCORM parameters
	//   ( completionThreshold)
	//  MXK 75%
	SUCCESS_THRESHOLD = 0.75;
	COMPLETEION_THRESHOLD = 1;
	POINTS = 0;
	MXK = true;
		
	// ==================================================================================================================================
	// 		labwork const
	// ==================================================================================================================================
	
	// labwork_loader speciefic const
	
	LABWORK_SEQUENCE_NONE = -1;
	LABWORK_SEQUENCE_SELECTION = 0;
	LABWORK_SEQUENCE_ONEBYONE = 1;
	
	// labwork_puzzle speciefic const
	
	PUZZLE_IMAGE_VERTICAL = 1;
	PUZZLE_IMAGE_HORIZONTAL = 2;
	PUZZLE_IMAGE_SQUARE = 3;
	
	PUZZLE_MODE_ONE = 0;
	PUZZLE_MODE_ALL = 1;
	
	// research
	
	RESEARCH_VISITED_PRESS = 0;
	RESEARCH_VISITED_RELEASE = 1;
	RESEARCH_VISITED_ROLLOVER = 2;
	RESEARCH_VISITED_ROLLOUT = 3;
	RESEARCH_VISITED_RIGHTPRESS = 4;
	RESEARCH_VISITED_RIGHTRELEASE = 5;

	//       (, )
	//      
	scene.MemObj = null;
	
	// ==================================================================================================================================
	//	common functions
	// ==================================================================================================================================
	
	//======================================================================================
	//      
	//   itemsTotal,    
	//   itemsTotal    originalArray
	
	function permutateArray(originalArray, itemsTotal){
		var numberArray = new Array();
		var newArray = new Array();
			
		if(originalArray instanceof Array){
			var bNewItem = false;
			var nItem = 0;
			if(!itemsTotal || itemsTotal == undefined || itemsTotal > originalArray.length)
				itemsTotal = originalArray.length;
			for(var i = 0; i < itemsTotal; i++){
				bNewItem = false;
				while(!bNewItem){
					nItem = Math.round(Math.random()*itemsTotal);
					//trace("new item: " + nItem);
					if(nItem != undefined && nItem < itemsTotal){
						if(scene.getOne(nItem, numberArray) == -1){
							bNewItem = true;
							numberArray.push(nItem);
						};
					};
				};
			};
			for(var i = 0; i < numberArray.length; i++){
				newArray.push(originalArray[numberArray[i]]);
			};
			numberArray = null;
			return newArray;
		} else {
			trace("ERROR: permutateArray: originalArray is not an instanceof Array.");
		};
	};
	
	
	// =======================================================================================
	//       
	//    ,  -1
	
	function getOne(nItem, searchInArray){
		var nFound = -1;
		for(var i = 0; i < searchInArray.length; i++){
			if(searchInArray[i] == nItem){
				nFound = i;
				break;
			};
		};		
		return nFound;
	};
	
	// =======================================================================================
	//	     
	//	  
	
	function replacestr(strSource, strFind, strReplace){
		var strProcessed = "";
		while (true) {
			var i = strSource.indexOf(strFind);
			if (i >= 0) {
				strProcessed = strProcessed + strSource.substr(0, i) + strReplace;
				strSource = strSource.substr(i + strFind.length);
			}else break;
		}
		return strProcessed + strSource;
	};
	
	function parseActionList(strSource){
		var newActions = (xmlAttribute.value).split(";");
		var resultArray = new Array();
		for(var i = 0; i < newActions.length; i++){
			var action = newActions[i].split(":");
			resultArray.push(action);
		};
		if(resultArray.length > 0)
			return resultArray;
		else
			return null;
	};
	
	// =========================================================================================
	//
	
	//     :
	
    function secondsToMinSec(seconds){
		var secondsTotal = seconds % 3600;
		var secTotal = secondsTotal % 60;
		var minTotal = (secondsTotal - secTotal)/60;
		var resultStr = "";
		if(minTotal > 9)
			resultStr = resultStr + minTotal;
		else 
			resultStr = resultStr + "0" + minTotal;
		resultStr = resultStr + ":";
		if(secTotal > 9)
			resultStr = resultStr + secTotal;
		else 
			resultStr = resultStr + "0" + secTotal;
		return resultStr;
    }
	
	//   :  		
	
	function minSecToSeconds(timeString){
		var timeParts = timeString.split(":");
		return (parseInt(timeParts[0])*60 + parseInt(timeParts[1]));
	}
	
	// ==================================================================================================================================
	//	  common-
	// ==================================================================================================================================
	
	//	
	function initTextFromNode(srcNode, objParent){
		if(srcNode.nodeName == "text"){
			var newText = new Composition();
			newText._class = "common_text";
			newText.parent = objParent;
			newText.initFromNode(srcNode);
			return newText;
		};	
	};
	
	//	
	function initImageFromNode(srcNode, objParent){
		if(srcNode.nodeName == "image"){
			var newText = new Composition();
			newText._class = "common_image";
			newText.parent = objParent;
			newText.initFromNode(srcNode);
			return newText;
		};	
	};
	
	function initAudioFromNode(srcNode, objParent){
		if(srcNode.nodeName == "audio"){
			var newObject = new Composition();
			newObject._class = "common_audio";
			newObject.parent = objParent;
			newObject.initFromNode(srcNode);
			return newObject;
		};
	};
	
	function initVideoFromNode(srcNode, objParent){
		if(srcNode.nodeName == "video"){
			var newObject = new Composition();
			newObject._class = "common_video";
			newObject.parent = objParent;
			newObject.initFromNode(srcNode);
			return newObject;
		};
	};
	
	function initFlashFromNode(srcNode, objParent){
		if(srcNode.nodeName == "flash"){
			var newObject = new Composition();
			newObject._class = "common_flash";
			newObject.parent = objParent;
			newObject.initFromNode(srcNode);
			return newObject;
		};	
	};
	
	function initQTFromNode(srcNode, objParent){
		if(srcNode.nodeName == "quicktime"){
			var newObject = new Composition();
			newObject._class = "common_quicktime";
			newObject.parent = objParent;
			newObject.initFromNode(srcNode);
			return newObject;
		};	
	};

	function initCollectionFromNode(srcNode, objParent){
		if(srcNode.nodeName == "collection"){
			var newObject = new Composition();
			newObject._class = "common_collection";
			newObject.parent = objParent;
			newObject.initFromNode(srcNode);
			return newObject;
		};	
	};
	
	//	===============================================================================================
	//	 
	//	===============================================================================================
	
	function initButtonFromNode(srcNode, objParent){
		if(srcNode.nodeName == "button"){
			var newObject = new Composition();
			newObject._class = "common_button";
			newObject.parent = objParent;
			newObject.initFromNode(srcNode);
			return newObject;
		};	
	};

	function initTextboxFromNode(srcNode, objParent){
		//trace("scene.initTextboxFromNode()");
		//if(srcNode.nodeName == "textbox"){
			var newObject = new Composition();
			newObject._class = "common_textbox";
			newObject.parent = objParent;
			newObject.initFromNode(srcNode);
			return newObject;
		//};	
	};

	function initControlGroupFromNode(srcNode, objParent){
		if(srcNode.nodeName == "group"){
			var newObject = new Composition();
			newObject._class = "common_controlgroup";
			newObject.parent = objParent;
			newObject.initFromNode(srcNode);
			return newObject;
		};	
	};

	function initPlayControlFromNode(srcNode, objParent){
		if(srcNode.nodeName == "playcontrol"){
			var newObject = new Composition();
			newObject._class = "common_playcontrol";
			newObject.parent = objParent;
			newObject.initFromNode(srcNode);
			return newObject;
		};	
	};

